#!/bin/bash

pushd . > /dev/null
SCRIPT_PATH="${BASH_SOURCE[0]}";
if ([ -h "${SCRIPT_PATH}" ]) then
  while([ -h "${SCRIPT_PATH}" ]) do cd `dirname "$SCRIPT_PATH"`; SCRIPT_PATH=`readlink "${SCRIPT_PATH}"`; done
fi
cd `dirname ${SCRIPT_PATH}` > /dev/null
SCRIPT_PATH=`pwd`;
pushd $SCRIPT_PATH > /dev/null

mkdir -p ./fpcobj

fpc -MObjFPC -Sc -Sg -Si -Sh -O1 -Pi386 -Tlinux -gw -gl -g -gl -godwarfsets -v0 -Fu./fpc -Fl./fpc -FU./fpcobj -FE./fpc -o./c/libfpclib.so fpc/fpclib.lpr

pushd ./c > /dev/null

gcc -m32 -Wall -L. -lssl -lcrypto -lfpclib -o openssl_test openssl_test.c

LD_LIBRARY_PATH=. ./openssl_test

popd > /dev/null

rm -f ./fpcobj/*
rmdir ./fpcobj

popd > /dev/null
popd > /dev/null
